#include <stdio.h>
#include <math.h>
#include <GL/glut.H>

//`̂߂̓_̐
#define N 100

//Ȑ x W  y W
float px[N];
float py[N];

//_̍W
float cx[4] = {-0.75, -0.5, 0.5,  0.75};
float cy[4] = {-0.5,   0.5,  0.5,  -0.5};

//WvZ֐
void generatePoints(){
  for(int i=0; i<N; i++){
    //ۑ2-1: ȉ𖄂߂3̃xWGȐ̓_ px[i]  py[i] ֒l
    float t = (float)i/(N-1); //o[^ t
    
    float B0 = (1-t)*(1-t)*(1-t); 
    float B1 = 3*(1-t)*(1-t)*t;
    float B2 = 3*t*t*(1-t);
    float B3 = t*t*t;
    px[i] = B0*cx[0] + B1*cx[1] + B2*cx[2] + B3*cx[3];
    py[i] = B0*cy[0] + B1*cy[1] + B2*cy[2] + B3*cy[3];
  }
}

//܂`֐
void drawCurve(){
  glLineWidth(3); //
  glColor3f(0,0,0); //F͍
  
  //ۑ1-2: JԂgĐ`Ă
  glBegin(GL_LINES);
  for(int i=0; i<N-1; i++){
    glVertex3f(px[i], py[i], 0);
    glVertex3f(px[i+1], py[i+1], 0);
  }
  glEnd();
}

void moveControlPoints(float x, float y){
  //ۑ2-2 : _̈ړ
  
  int k = 0; //k ͍ł߂_̔ԍ (bI 0 ԂƂȂĂ)
  //ȉ (x,y)  (cx[0], cy[0]) ̊Ԃ̋2
  float min = (x-cx[0])*(x-cx[0]) + (y-cy[0])*(y-cy[0]);
  
  //ۑ͈ȉ𖄂߂ (̐_Ƃ̋v k XV)
  for(int i=1; i<4; i++){
    float d = (x-cx[i])*(x-cx[i]) + (y-cy[i])*(y-cy[i]);
    if(d < min){
      min = d;
      k = i;
    }
  }
  
  //_̍XV
  cx[k] = x;
  cy[k] = y;
}

//Ȑ̖@xNg ( 1 Ƃ)
float nx[N];
float ny[N];

void computeNormals(){
  for(int i=0; i<N; i++){
    //ۑ3-1: ȉ𖄂߂3̃xWGȐ̖@ nx[i]  ny[i] ֒l
    float t = (float)i/(N-1);
    
    //֐̔
    float dB0 = -3*(1-t)*(1-t); 
    float dB1 = 3*(1-t)*(1-3*t);
    float dB2 = 3*t*(2-3*t);
    float dB3 = 3*t*t;
    
    float dx = dB0*cx[0] + dB1*cx[1] + dB2*cx[2] + dB3*cx[3];
    float dy = dB0*cy[0] + dB1*cy[1] + dB2*cy[2] + dB3*cy[3];
    
    float l = sqrt(dx*dx + dy*dy);
    //@xNg͐ڐxNg90x]xNg
    nx[i] = -dy/l;
    ny[i] = dx/l;
  }
}

void drawOffsetCurves(){
  glLineWidth(1); //
  glColor3f(0,1,1); //F͐F
  
  //ۑ3-2  3-3 : ItZbgȐ`
  glBegin(GL_LINES);
  for(int j=-10; j<=10; j++){
    if(j != 0){
      for(int i=0; i<N-1; i++){
        glVertex3f(px[i]+0.1*j*nx[i], py[i]+0.1*j*ny[i], 0);
        glVertex3f(px[i+1]+0.1*j*nx[i+1], py[i+1]+0.1*j*ny[i+1], 0);
      }
    }
  }
  glEnd();
}

//ȗa
float R[N];

void computeCurvatureRadius(){
  for(int i=0; i<N; i++){
    //ۑ4-1: ȉ𖄂߂3̃xWGȐ̋ȗ cur[i] ֒l
    float t = (float)i/(N-1);
    
    //֐1K
    float dB0 = -3*(1-t)*(1-t); 
    float dB1 = 3*(1-t)*(1-3*t);
    float dB2 = 3*t*(2-3*t);
    float dB3 = 3*t*t;
    
    float dx = dB0*cx[0] + dB1*cx[1] + dB2*cx[2] + dB3*cx[3];
    float dy = dB0*cy[0] + dB1*cy[1] + dB2*cy[2] + dB3*cy[3];
    
    //֐2K
    float ddB0 = 6*(1-t); 
    float ddB1 = 6*(3*t-2);
    float ddB2 = 6*(1-3*t);
    float ddB3 = 6*t;
    
    float ddx = ddB0*cx[0] + ddB1*cx[1] + ddB2*cx[2] + ddB3*cx[3];
    float ddy = ddB0*cy[0] + ddB1*cy[1] + ddB2*cy[2] + ddB3*cy[3];
    
    R[i] = pow(dx*dx+dy*dy, 1.5f)/(dx*ddy - dy*ddx);
  }
}

//k`֐
void drawEvolue(){
  glLineWidth(2); //
  glColor3f(1,0,0); //F͐ԐF
  
  //ۑ4-2 : k`
  glBegin(GL_LINES);
  for(int i=0; i<N-1; i++){
    if(R[i]*R[i+1] > 0){ //ȗ̂̕ݕ`
      glVertex3f(px[i]+R[i]*nx[i], py[i]+R[i]*ny[i], 0);
      glVertex3f(px[i+1]+R[i+1]*nx[i+1], py[i+1]+R[i+1]*ny[i+1], 0);
    }
  }
  glEnd();
}

//_O̊֐
void display(void){ 
  //XN[ƕϊs
  glClear(GL_COLOR_BUFFER_BIT); 
  glLoadIdentity();
  
  //W`
  glLineWidth(1); 
  glColor3f(0,0,1); 
  glBegin(GL_LINES);
    glVertex3f(-1, 0, 0); glVertex3f( 1, 0, 0);
    glVertex3f(0, -1, 0); glVertex3f(0,  1, 0);
  glEnd();
  
  //_`
  glLineWidth(2); 
  glColor3f(0,1,0); 
  glBegin(GL_LINE_STRIP);
    glVertex3f(cx[0], cy[0], 0);
    glVertex3f(cx[1], cy[1], 0);
    glVertex3f(cx[2], cy[2], 0);
    glVertex3f(cx[3], cy[3], 0);
  glEnd();
  
  glPointSize(10);
  glBegin(GL_POINTS);
    glVertex3f(cx[0], cy[0], 0);
    glVertex3f(cx[1], cy[1], 0);
    glVertex3f(cx[2], cy[2], 0);
    glVertex3f(cx[3], cy[3], 0);
  glEnd();

  //Ȑ`
  drawCurve();
  
  //ItZbg`
  drawOffsetCurves();
  
  //k`
  drawEvolue();
  
  glFlush(); //XN[֕\
} 

//EBhȆ傫ςɌĂ΂֐
int width, height;
void myReshape(int w, int h){
  width = w;
  height = h;
  
  glViewport(0, 0, w, h); //XN[̑傫߂
  
  //ϊsݒ
  glMatrixMode(GL_PROJECTION); 
  glLoadIdentity();
  
  //sê߂̃p[^ݒ
  //̈ (-1,-1,-1)  (1,1,1) R[i[Ɏ̂̒
  glOrtho(-1, 1, //E
          -1, 1, //
          -1, 1 //O
          );
  
  glMatrixMode(GL_MODELVIEW); //}``惂[h֐؂ւ
} 

void myinit(){
  //wi̐Fݒ (SԖڂ͓ߓxŒʏ͕sȂ̂ 1 ݒ)
  glClearColor (1, 1, 1, 1);

}

//}EX̊֐
void mouse(int btn, int state, int x, int y){
  moveControlPoints(2*(float)x/width-1, 2*(float)(height-y)/height-1);
  
  //Ȑ̓_lČvZ
  generatePoints();
  computeNormals();
  computeCurvatureRadius();
  
  //ĕ`
  display();
}

int main(int argc, char** argv){
  //Ȑ̓_lvZ
  generatePoints();
  computeNormals();
  computeCurvatureRadius();
  
  //EBhȄ
  glutInit(&argc, argv); 
  glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB); //gpobt@̐ݒ
  glutInitWindowSize(500, 500); //EBhȆ傫
  glutCreateWindow("1-1"); //EBhẼ^Cg
  
  myinit();//OpenGL ̏
  glutReshapeFunc(myReshape);//EBhETCYύXꂽɌĂ΂֐ݒ
  glutMouseFunc(mouse); //}EX삳ꂽƂɌĂ΂֐ݒ
  glutDisplayFunc(display); //EBhE̍XV̂߂̊֐ݒ
  glutMainLoop(); //C[v
  
  return 0;
}

